
var tamanho = location.href.lastIndexOf('/');
var arquivo = location.href.substring(tamanho+1);
var numero = arquivo.lastIndexOf('.');
var pageNumber = arquivo.substring(0,numero);

$(document).ready(function(event) {
	var questionArea = $('body > .page > .conteudo > .questionArea');
	questionArea.empty();
	questionArea.html(
				'<div name="text-local"><textarea name="question" data-id="" class="form-control answer" style="margin: 1em 0;" placeholder="Insira a resposta aqui!"></textarea></div>'+

                
                '<div id="btns" style="position: relative; width: 90%; margin: auto auto;">'+
                    
                    '<button type="button" name="feedback" class="btn btn-primary modal-btn"'+
                        'style="position: absolute; vertical-align: middle; left: 0;"'+
                        'data-modal-selector="#mFeedback">'+
                        'Feedback'+
                    '</button>'+

                    
                    '<button type="button" name="edit" class="btn"'+
                        'style="position: absolute; vertical-align: middle; right: 0;"'+
                        'onclick="editAnswer()">'+
                        'Editar'+
                    '</button>'+
                    '<button type="button" name="send" class="btn btn-success"'+
                        'style="position: absolute; vertical-align: middle; right: 0;"'+
                        'onclick="sendAnswer()">'+
                        'Enviar'+
                    '</button>'+
                '</div>'+
                '<div id="div-ajax" class="note" style="margin: 3em auto;">'+
                '<div class="note answerSucess" name="sucessNote">'+
                       ' Resposta enviada com sucesso. Você pode clicar no botão <strong>Feedback</strong> e comparar sua resposta ou no botão <strong>Editar</strong> para alterar a resposta já enviada.'+
                    '</div>'+
                 '<div class="note answerError" name="errorNote">'+
                    'Por favor, digite uma resposta para poder enviar.'+
                  '</div>'+
            '</div>'

	);
	//Ocultando os botões, por default
	$("button[name=send]").hide();
	$("button[name=edit]").hide();
	$("button[name=feedback]").hide();
	$("div[name=sucessNote]").hide();
	$("div[name=errorNote]").hide();

	//cuidando da caixa de texto:
	

	//Buscando os dados de respostas no LocalStorage:
	var _answer = getAnswer(pageNumber);

	//Integrando o enunciado da questão:
	$("textarea[name=question]").attr('data-id', pageNumber);
	$("textarea[name=question]").append(
	   _answer
	);
	$("div[name=text-local]").hide();
	$("div[name=text-local]").get(0).offsetHeight;
	$("div[name=text-local]").show();


	//Se tiver algo a ser mostrado dentro da text area
	if (_answer.length > 0){
	    //Ocultar o botao de enviar
	    $("button[name=send]").hide();
	    $("button[name=edit]").show();
	    $("button[name=feedback]").show();
	    //Desabilitar a textarea
	    $("textarea[name=question]").attr("disabled", "disabled");

	}else{
	    //Tem nada armazenado, então mostrar enviar: 
	    $("button[name=send]").show();
	    $("button[name=edit]").hide();
	    $("button[name=feedback]").hide();
	}




});

function getAnswer(nPage){
    $("button[name=send]").show();
    //Recuperar os dados armazenados
    var answerTable = localStorage.getItem("answerTableProcessos");

    //Converter para ser utilizado
    answerTable = JSON.parse(answerTable);

    //Se a tabela de respostas for igual a NULL, retornar string vazia
    if (answerTable == null) {return "";} 

    //Andar na tabela para saber se está armazenado:
    for (var i = 0; i < answerTable.length; i++) {
        tmp = JSON.parse(answerTable[i]);
        if (tmp.id_answer == nPage){
            return tmp.content_answer;
        }
    }
    return "";
}



function editAnswer(){
    //Habilitar a text area
    $("textarea[name=question]").removeAttr("disabled");
    //Levar o cursor ate la
    //Ocultar o botao de editar
    $("button[name=edit]").hide();
    //Mostrar o botao de enviar
    $("button[name=send]").show();
    $("textarea[name=question]").focusin();
}

function sendAnswer(){
    var answer = $("textarea[name=question]").val();
    console.log(answer);

    if (answer.length > 0){
        //Ocultar o botao de enviar
        $("button[name=send]").hide();

        //Desabilitar a textarea
        $("textarea[name=question]").attr("disabled", "disabled");

        //Mostrar o botao de editar
        $("button[name=edit]").show();

        //Mostrar o botao de feedback
        $("button[name=feedback]").show();

        $("div[name=errorNote]").hide();
        $("div[name=sucessNote]").show();
        
        console.log('respondido');

        //Enviar resposta:
        insertAnswer(pageNumber, answer);

        //Mostrar nota de envio
        //$("#div-ajax").html('');
        //$("#div-ajax").append(
        //    '<div class="note answerSucess">'
        //        + 'Resposta enviada com sucesso. Você pode clicar no botão <strong>Feedback</strong> e comparar sua resposta ou no botão <strong>Editar</strong> para alterar a resposta já enviada.' +
        //    '</div>'
        //);


    }else{
        //Mostrar nota de aviso
        //$("#div-ajax").html('');
        //$("#div-ajax").append(
         //   '<div class="note answerError">'
         //       + 'Por favor, digite uma resposta para poder enviar.' +
         //   '</div>'
        //);
        $("div[name=sucessNote]").hide();
        $("div[name=errorNote]").show();
        console.log('errado');
    }
}

// ============= LIDANDO COM INSERÇÃO E REMOÇÃO DOS DADOS ================

//Inserir uma resposta ou atualizar a que ja esta na tabela:
function insertAnswer(idQuestion, _answer){
    //Quando for recuperar, lembrar de dar um parse
    var answer = JSON.stringify({
        id_answer: idQuestion,
        //Quem sabe melhorar o nome da text area (atual: b):
        content_answer: _answer
    }); 
    
    //Recuperar os dados armazenados
    var answerTable = localStorage.getItem("answerTableProcessos");
    //Converter em um objeto para ser utilizado
    answerTable = JSON.parse(answerTable);

    //Se a tabela de respostas for igual a NULL, somente criar uma tabela de respostas logo
    if (answerTable == null) {
        answerTable = [];
    } 

    var pos = -1;
    //Andar na tabela para saber se já existe:
    for (var i = 0; i < answerTable.length; i++) {
        tmp = JSON.parse(answerTable[i]);
        //console.log(tmp.id_answer);
        //console.log(idQuestion);
        if (tmp.id_answer == idQuestion){
            pos = i;
            break;
        }
    }

    //Decidir o que fazer com a resposta:
    if (pos < 0){
        //Adicionar resposta
        answerTable.push(answer);
    }else{
        //Atualizar ele
        answerTable[pos] = answer;
    }

    localStorage.setItem("answerTableProcessos", JSON.stringify(answerTable));
    console.log("Resposta adicionada com sucesso!");

    return true;  
}

