
/*
 *
 *   Basic functions
 * 
 *   @author  Luis Filipe <lionphilips@gmail.com>
 * 
 *   include jquery
 *   inclue  jquery-xmlrpc
*/

/* get URL params */
var urlParam = function(name){
    var results = new RegExp('[\?&]' + name + '=([^&#]*)').exec(window.location.href);
    return results[1] || 0;
}

var encode_utf8 = function(text) { //PS: if string have especial characters, I must you this function.
    return unescape(encodeURIComponent(text));
}

/* very simple XML-RPC request */
var send_xmlrpc = function(URL, token, method, params) {
    $.xmlrpc({
        url: URL + token,
        methodName: method,
        params: params,
        success: function(response, status, jqXHR) {
            return response;
        },
        error: function(jqXHR, status, error) {
            return error;
        }
    });
}
