//Páginas Questões Norteadoras
//As paginas devem ser cadastradas em ordem crescente
//Format: [[NumeroPagina, IdQuestao], [NumeroPagina, IdQuestao]...[NumeroPagina, IdQuestao]]
PAG_QUEST_NORT = [[3, 16439],[8, 16440],[13, 16441],[20, 16442],[26, 16443],[35, 16444]];

//Utilizado validateQuestionNorteBefore
var bRedirect = false;

//Variavel Global para armazenar as questoes norteadoras
var arrayElementsQuestionNorteadoras = []

function browserSupportLocalStorage() {
	if (typeof(Storage) == undefined)
		alert("Navegador não suporta LocalStorage");

	return true;
}

function findIdQuestionPage(numberPage) {
	for(iLaco = 0; iLaco < PAG_QUEST_NORT.length; iLaco++) {
		if (PAG_QUEST_NORT[iLaco][0] == numberPage){
			return PAG_QUEST_NORT[iLaco][1];
		}			
	}

	return -1;
}

function findPageReturnPosition(numberPage) {
	for(iLaco = 0; iLaco < PAG_QUEST_NORT.length; iLaco++) {
		if (PAG_QUEST_NORT[iLaco][0] == numberPage){
			return iLaco;
		}			
	}

	return -1;
}

function findPageIdQuestion(idQuestion) {
	for(iLaco = 0; iLaco < PAG_QUEST_NORT.length; iLaco++) {
		if (PAG_QUEST_NORT[iLaco][1] == idQuestion){
			return PAG_QUEST_NORT[iLaco][0];
		}			
	}

	return -1;	
}

function isQuestionNorte(numberPage) {
	if (findPageReturnPosition(numberPage) == -1)
		return false;

	return true;
}

function existsQuestionNorteBeforePage(numberPage) {
	var index = PAG_QUEST_NORT.length - 1;

	for(iLaco = 5; iLaco >= 0; iLaco--) {
		if (PAG_QUEST_NORT[iLaco][0] <= numberPage) {
			if (PAG_QUEST_NORT[iLaco][0] == numberPage)
				return iLaco - 1;
			return iLaco;
		}									
	}
	return -1;
}

function getNextQuestionAnswered() {
	for(iLaco = 0; iLaco < arrayElementsQuestionNorteadoras.length; iLaco++) {
		if (arrayElementsQuestionNorteadoras[iLaco].answer == null) {
			return arrayElementsQuestionNorteadoras[iLaco];
		}
	}

	//PAGES_TOTAL - variavel do config-livro.js
	return { page : PAGES_TOTAL, idQuestion : 0, answer : "" };
}

function updateStructureLocalStorage(feedback, user, numberPage, answer) {
	var objectPage = {
		page : numberPage,
		idQuestion : findIdQuestionPage(numberPage),
		answer : answer
	};

	for(iLaco = 0; iLaco < arrayElementsQuestionNorteadoras.length; iLaco++) {
		if (arrayElementsQuestionNorteadoras[iLaco].page == numberPage) {
			arrayElementsQuestionNorteadoras[iLaco] = objectPage;
			localStorage.setItem(feedback + "#" + user, JSON.stringify(arrayElementsQuestionNorteadoras));
			break;
		}

	}
}

function validateQuestionNorte(numberPage, feedback, user) {
	
	if (checkCreateVariableLocalStorage(numberPage, feedback, user)) {
		//Validando as questoes caso o usuário mude a URL		
		if ((indexQuestion = existsQuestionNorteBeforePage(numberPage)) != -1) {
			bRedirect = false;
			objectPageValidate = validateQuestionNorteBefore(indexQuestion, feedback, user);
			// if (objectPageValidate.redirect) {
			// 	window.location.href = objectPageValidate.page + ".html?feedback=" + feedback + "&user=" + user;
			// }
		}		

		//Verifica se a questao é Norteadora
		if (isQuestionNorte(numberPage)) {
			idQuestion = findPageReturnPosition(numberPage);
			// if (arrayElementsQuestionNorteadoras[idQuestion].answer == null) {
			// 	$(".avancar").addClass('disabled').attr('title', 'Você precisa responder a questão');
			// }
		}

		// objectPage = getNextQuestionAnswered();
		// $("#navigator_menu li").each(function() {
		// 	$(this).find("a").removeClass('disabled');
		// 	$(this).find("a").attr("data-href", $(this).find("a").attr("href"));
		// 	if (parseInt($(this).find("a").text()) > objectPage.page)
		// 		$(this).find("a").addClass('disabled').attr("href", "#");
		// });
	} else {
		console.log("Criar uma mensagem para o usuário.");
		console.log("Criando variáveis de ambiente... aguarde...");
	}

}

function validateQuestionNorteBefore(indexQuestion, feedback, user) { 
	if (indexQuestion < 0) {		
		return { redirect : bRedirect, page : 1 };
	}

	if ((arrayElementsQuestionNorteadoras[indexQuestion].answer == null))
		bRedirect = true;

	if ((arrayElementsQuestionNorteadoras[indexQuestion].answer != null)) {
		return { redirect : bRedirect, page : arrayElementsQuestionNorteadoras[indexQuestion].page };
	}

	return validateQuestionNorteBefore(--indexQuestion, feedback, user);
}

function checkCreateVariableLocalStorage(numberPage, feedback, user) {
	browserSupportLocalStorage();

	if ((elementStorage = localStorage.getItem(feedback + "#" + user)) == null) {
		createArrayLocalStorage(numberPage, feedback, user);
		return false;
	} else {
		arrayElementsQuestionNorteadoras = JSON.parse(localStorage.getItem(feedback + "#" + user));
		// console.log(arrayElementsQuestionNorteadoras);
	}
	return true;
}

function createArrayLocalStorage(numberPage, feedback, user) {
	var iCounter = 0;
	arrayElementsQuestionNorteadoras = [];

	while ((iCounter < PAG_QUEST_NORT.length)) {		
		functionSuccess = function(retorno) {
			var iLaco = 0; 
			data = getObjectXMLRPC(retorno);
			for(iLaco = 0; iLaco < PAG_QUEST_NORT.length; iLaco++) {
				if (PAG_QUEST_NORT[iLaco][1] == data.id)
					break;			
			}				
			object = { page : PAG_QUEST_NORT[iLaco][0], idQuestion : data.id, answer : data.answer };
			arrayElementsQuestionNorteadoras.push(object);

			if (arrayElementsQuestionNorteadoras.length == PAG_QUEST_NORT.length) {
				functionSort = function(a, b){return a.page-b.page}
				arrayElementsQuestionNorteadoras.sort(functionSort);

				localStorage.setItem(feedback + "#" + user, JSON.stringify(arrayElementsQuestionNorteadoras));
				// console.log(arrayElementsQuestionNorteadoras);

				window.location.href = "1.html?feedback=" + feedback + "&user=" + user;				
			}
		};
		
		executeXMLRPCfunction(feedback, user, PAG_QUEST_NORT[iCounter][1], functionSuccess);
		iCounter++;	
	}
}

function getObjectXMLRPC(dataObject) {
	var data = JSON.parse(dataObject);
	data = data[Object.keys(data)[0]];
	return data;	
}

function executeXMLRPCfunction(feedback, user, idQuestion, functionSuccess, functionError) {
	$.xmlrpc({
		url: 'http://avaunasus.ufma.br/webservice/xmlrpc/server.php?wstoken=76e231a35a971d69d8d0c3fc667d0ecb',
		methodName: 'local_wsebook2_question',
		params: [feedback, idQuestion.toString(), user],
		success: functionSuccess,
		error: function(status) {
			if (functionError != undefined) {
				functionError();
			} else {
				console.log("Ocorreu um erro ao processar a requisição RPC.");
				console.log(status);
			}
		}
	});
}

function sendQuestionXMLRPCfunction(feedback, user, idQuestion, answer, functionSuccess, functionError) {
	$.xmlrpc({
		url: 'http://avaunasus.ufma.br/webservice/xmlrpc/server.php?wstoken=6c3c3ebe21ff26f0673f577ae7dc4949',
		methodName: 'local_wsebook2_new_answer',
		params: [feedback, user, idQuestion.toString(), answer],
		success: functionSuccess,
		error: function(status) {
			if (functionError != undefined) {
				functionError();
			} else {
				console.log("Ocorreu um erro ao processar a requisição RPC.");
				console.log(status);
			}
		}
	});
}